Compare commits

..

2 Commits

Author SHA1 Message Date
ee188a30d7 efficiency, don't apt update again if already done 2025-03-29 00:30:17 -07:00
2707542a45 make update logic smarter 2025-03-29 00:27:49 -07:00

View File

@ -2,6 +2,10 @@
set -euo pipefail
function apt_update_if_stale () {
[ -z "$(find /var/lib/apt/lists -type f -mmin -30 2>/dev/null)" ] && apt-get update
}
function main () {
# check for ubuntu only
if ! grep -qi '^ID=ubuntu' /etc/os-release; then
@ -25,15 +29,25 @@ function main () {
find /etc/apt/sources.list.d/ -type f -exec \
sed -i "s|archive\.ubuntu\.com|us.ubuntu.com|g" {} +
apt_update_if_stale
apt install -y jq curl
echo "Detecting actual country..." > /dev/stderr
apt update && apt install -y curl jq
IPINFO="$(curl -s ipinfo.io)"
if [ -z "$IPINFO" ]; then
echo "Failed to get IP info" > /dev/stderr
exit 1
fi
COUNTRYCODE="$(jq .country -r <<< "$IPINFO")"
if [[ -z "$COUNTRYCODE" ]]; then
echo "Failed to get country code" > /dev/stderr
exit 1
fi
echo "IP geolocated as country: $COUNTRYCODE" > /dev/stderr
if ! grep -qE 'http(s)?://us\.archive\.ubuntu\.com/' /etc/apt/sources.list.d/*; then
@ -42,7 +56,7 @@ function main () {
fi
if [[ "$COUNTRYCODE" == "US" ]]; then
echo "Mirror already set to US, nothing to do" > /dev/stderr
echo "Mirror already set to US, nothing to do" > /dev/stderr
exit 0
fi